using System.Collections.Generic;


namespace PAT.Common.Classes.Expressions.ExpressionClass
{

    public enum ExpressionType : byte
    {
        Constant,
        Variable,
        Record,
        PrimitiveApplication,
        Assignment,
        PropertyAssignment,
        If,
        Sequence,
        While,
        Let,
        StaticMethodCall,
        ClassMethodCall,
        NewObjectCreation,
        ClassMethodCallInstance,
        ClassProperty,
        ClassPropertyAssignment
        //Fun,
        //RecFun,
        //Application

    }

    public abstract class Expression
    {
        public ExpressionType ExpressionType;
        internal string expressionID;
        public virtual string ExpressionID
        {
            get
            {
                return expressionID;
            }
        }

        public virtual List<string> GetVars()
        {
            return new List<string>(0);
        }

        public bool HasVar;

        public virtual Expression ClearConstant(Dictionary<string, Expression> constMapping)
        {
            return this;
        }


        public virtual bool HasExternalLibraryCall () 
        {
            return false;
        }
    }

    public abstract class ExpressionValue: Expression
    {
        //public abstract string GetID();

        public virtual ExpressionValue GetClone()
        {
            return this;
        }
    }
}