using System;
using System.Collections.Generic;

namespace PAT.Common.Classes.Expressions.ExpressionClass
{
    public sealed class LetDefinition : Expression
    {
        public string Variable;
        public Expression RightHandExpression;
       
        public LetDefinition(String v, Expression rhe) 
        {
            Variable = v; 
            RightHandExpression = rhe;
            HasVar = true;
            ExpressionType = ExpressionType.Let;

            expressionID = Variable + "=" + RightHandExpression.ExpressionID;

        }

        public override String ToString()
        {
            return "var " +Variable + " = " + RightHandExpression + ";";
        }

        //public override String GetID()
        //{
        //    return Variable + "=" + RightHandExpression.GetID();
        //}

        public override List<string> GetVars()
        {
            List<string> vars = this.RightHandExpression.GetVars();
            if (!vars.Contains(Variable))
            {
                vars.Add(Variable);
            }
            return vars;
        }

        public override Expression ClearConstant(Dictionary<string, Expression> constMapping)
        {
            return new LetDefinition(Variable, RightHandExpression.ClearConstant(constMapping));
        }

        public override bool HasExternalLibraryCall()
        {
            return RightHandExpression.HasExternalLibraryCall();
        }
    }
}