using System;
using System.Collections.Generic;

namespace PAT.Common.Classes.Expressions.ExpressionClass
{
    public sealed class PropertyAssignment : Expression
    {
        public Expression RecordExpression, PropertyExpression, RightHandExpression;

        public PropertyAssignment(Expression rec, Expression p, Expression rhs)
        {
            RecordExpression = rec;
            PropertyExpression = p;
            RightHandExpression = rhs;
            ExpressionType = ExpressionType.PropertyAssignment;
            this.HasVar = RecordExpression.HasVar || PropertyExpression.HasVar || rhs.HasVar;

            expressionID = RecordExpression.ExpressionID + "[" + PropertyExpression.ExpressionID + "]=" + RightHandExpression.ExpressionID;

        }
        public override String ToString()
        {
            return RecordExpression + "[" + PropertyExpression + "]=" + RightHandExpression + ";";
        }

        //public override String GetID()
        //{
        //    return RecordExpression.GetID() + "[" + PropertyExpression.GetID() + "]=" + RightHandExpression.GetID();
        //}

        public override List<string> GetVars()
        {
            List<string> vars = this.RecordExpression.GetVars();
            Ultility.Ultility.AddList(vars, this.PropertyExpression.GetVars());
            Ultility.Ultility.AddList(vars, this.RightHandExpression.GetVars());
            return vars;
        }

        public override Expression ClearConstant(Dictionary<string, Expression> constMapping)
        {
            return    new PropertyAssignment(RecordExpression.ClearConstant(constMapping),
                                       PropertyExpression.ClearConstant(constMapping),
                                       RightHandExpression.ClearConstant(constMapping));        
        }

        public override bool HasExternalLibraryCall()
        {
            return RecordExpression.HasExternalLibraryCall() || PropertyExpression.HasExternalLibraryCall() ||
                   RightHandExpression.HasExternalLibraryCall();         
        }
    }
}