﻿using System;
using System.Collections.Generic;


namespace PAT.Common.Classes.Expressions.ExpressionClass
{
    /// <summary>
    /// This class is used for BDD to encode new variable value after transition
    /// </summary>
    public sealed class VariablePrime : Expression
    {
        public VariablePrime(String name)
        {
            //VarName = nam;
            HasVar = true;
            ExpressionType = ExpressionType.Variable;
            expressionID = name;
        }

        public override String ToString()
        {
            return expressionID;
        }

        //public override String GetID()
        //{
        //    return VarName;
        //}

        public override List<string> GetVars()
        {
            List<string> vars = new List<string>(1);
            vars.Add(expressionID);
            return vars;
        }

        public override Expression ClearConstant(Dictionary<string, Expression> constMapping)
        {
            if (constMapping.ContainsKey(expressionID))
            {
                return constMapping[expressionID];
            }

            return new VariablePrime(expressionID);
        }

    }
}
