using PAT.Common.Classes.Assertion;
using PAT.Common.Classes.LTS;
using PAT.Common.Classes.ModuleInterface;
using PAT.Common.Classes.SemanticModels.LTS.Assertion;
using PAT.PAR.LTS;

namespace PAT.PAR.Assertions
{
    public class PARAssertionRefinementF : AssertionRefinementF
    {
        private DefinitionRef ImplementationProcess;
        private DefinitionRef SpecificationProcess;

        public PARAssertionRefinementF(DefinitionRef processDef, DefinitionRef target) : base()
        {
            ImplementationProcess = processDef;
            SpecificationProcess = target;
        }

        public override void Initialize(SpecificationBase spec)
        {
            base.Initialize(spec);

            PARAssertion.Initialize(this, ImplementationProcess, SpecificationProcess, spec, 1);
        }

        public override string StartingProcess
        {
            get
            {
                return ImplementationProcess.ToString();
            }
        }

        public override string SpecProcess
        {
            get
            {
                return SpecificationProcess.ToString();
            }
        }
    }
}