using PAT.Common.Classes.Assertion;
using PAT.Common.Classes.LTS;
using PAT.Common.Classes.ModuleInterface;
using PAT.Common.Classes.SemanticModels.LTS.Assertion;
using PAT.PAR.LTS;

namespace PAT.PAR.Assertions
{
    public class PARSynthesisReachability : AssertionReachability
    {
        private DefinitionRef Process;

        public PARSynthesisReachability(DefinitionRef processDef, string reachableState)
            : base(reachableState)
        {
            Process = processDef;
        }

        public override void Initialize(SpecificationBase spec)
        {
            base.Initialize(spec);

            Specification Spec = spec as Specification;
            ReachableStateCondition = Spec.DeclarationDatabase[ReachableStateLabel];
            PARAssertion.Initialize(this, Process, spec);

        }

        public override string StartingProcess
        {
            get
            {
                return Process.ToString();
            }
        }

        public override string ToString()
        {
            return StartingProcess + " reaches " + ReachableStateLabel;
        }

        /// <summary>
        /// Run the verification and get the result.
        /// </summary>
        /// <returns></returns>
        public override void RunVerification()
        {


        }
    }
}