using PAT.Common.Classes.Assertion;
using PAT.Common.Classes.LTS;
using PAT.Common.Classes.ModuleInterface;
using PAT.Common.Classes.SemanticModels.LTS.Assertion;
using PAT.PAR.LTS;

namespace PAT.PAR.Assertions
{
    public class PARSynthesisRefinement : AssertionRefinement
    {
        public DefinitionRef ImplementationProcess;
        public DefinitionRef SpecificationProcess;
        protected byte InitTimerID = 1;

        public PARSynthesisRefinement(DefinitionRef processDef, DefinitionRef target)
            : base()
        {
            ImplementationProcess = processDef;
            SpecificationProcess = target;
        }

        public override void Initialize(SpecificationBase spec)
        {
            base.Initialize(spec);

            PARAssertion.Initialize(this, ImplementationProcess, SpecificationProcess, spec, InitTimerID);
        }

        public override string StartingProcess
        {
            get
            {
                return ImplementationProcess.ToString();
            }
        }

        public override string SpecProcess
        {
            get
            {
                return SpecificationProcess.ToString();
            }
        }


        /// <summary>
        /// Run the verification and get the result.
        /// </summary>
        /// <returns></returns>
        public override void RunVerification()
        {


        }
    }
}